package de.intevation.gnv.action;

import de.intevation.gnv.propertiesreader.PropertiesReaderFactory;
import de.intevation.gnv.propertiesreader.PropertiesReader;
import de.intevation.gnv.util.XMLUtils;

import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

import org.apache.log4j.Logger;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;        

import org.w3c.dom.Document;

/**
 * @author Ingo Weinzierl (ingo.weinzierl@intevation.de)
 */
public class LoadAction extends ArtifactDatabaseActionBase {

    public static final String RESOURCE_UPLOAD_FAILURE = "upload.failure";

    private static Logger logger = Logger.getLogger(LoadAction.class);

    public LoadAction() {
        super();
    }

    public ActionForward execute(
        ActionMapping       mapping,
        ActionForm          form,
        HttpServletRequest  request,
        HttpServletResponse response)
    throws Exception
    {
        logger.info("Import artifact.");

        ServletFileUpload upload  = new ServletFileUpload();
        Document artifactDocument = null;

        FileItemIterator iter = upload.getItemIterator(request);
        while (iter.hasNext()) {
            FileItemStream item = (FileItemStream) iter.next();
            String name         = item.getFieldName();

            if (name.equals("document")) {
                InputStream stream = item.openStream();
                artifactDocument   = XMLUtils.readDocument(stream);
            }
        }

        // no document found or not valid
        if (artifactDocument == null) {
            logger.error("Upload failure: No document found or invalid.");

            request.setAttribute(
                CommunicationKeys.REQUEST_EXCEPTION_PROJECT,
                RESOURCE_UPLOAD_FAILURE);

            return super.getExceptionForward(mapping);
        }

        // TODO Do something with our nice xml document
        // Use DescribeUI Action to set required attributes which are parsed in
        // jsp files.
        return super.execute(mapping, form, request, response);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
